diff --git a/gtk/window-decorator/gtk-window-decorator.c b/gtk/window-decorator/gtk-window-decorator.c
index d018a42..e19d770 100644
--- a/gtk/window-decorator/gtk-window-decorator.c
+++ b/gtk/window-decorator/gtk-window-decorator.c
@@ -236,6 +236,7 @@ int right_click_action  = RIGHT_CLICK_ACTION_DEFAULT;
 int wheel_action        = WHEEL_ACTION_DEFAULT;
 
 static gboolean minimal = FALSE;
+static gboolean reduced_resources = FALSE;
 
 static double decoration_alpha = 0.5;
 
@@ -304,8 +305,9 @@ static decor_shadow_t *switcher_shadow = NULL;
 static GdkPixmap *decor_normal_pixmap = NULL;
 static GdkPixmap *decor_active_pixmap = NULL;
 
-static Atom frame_window_atom;
 static Atom win_decor_atom;
+static Atom win_decor_active_atom;
+static Atom frame_window_atom;
 static Atom win_blur_decor_atom;
 static Atom wm_move_resize_atom;
 static Atom restack_window_atom;
@@ -371,6 +373,24 @@ static struct _pos {
     { 6, 2, 16, 16,   0, 0, 0, 0, 0, 0 }
 };
 
+static char *wm_action_name[3][3] = {
+    {
+	"_COMPIZ_WM_WINDOW_SIZE_TOPLEFT_DECOR",
+	"_COMPIZ_WM_WINDOW_SIZE_TOP_DECOR",
+	"_COMPIZ_WM_WINDOW_SIZE_TOPRIGHT_DECOR"
+    }, {
+	"_COMPIZ_WM_WINDOW_SIZE_LEFT_DECOR",
+	"_COMPIZ_WM_WINDOW_MOVE_DECOR",
+	"_COMPIZ_WM_WINDOW_SIZE_RIGHT_DECOR"
+    }, {
+	"_COMPIZ_WM_WINDOW_SIZE_BOTTOMLEFT_DECOR",
+	"_COMPIZ_WM_WINDOW_SIZE_BOTTOM_DECOR",
+	"_COMPIZ_WM_WINDOW_SIZE_BOTTOMRIGHT_DECOR"
+    }
+};
+static Atom wm_action_atom[3][3];
+static Atom wm_action_notify_atom[3][3];
+
 typedef struct _decor_color {
     double r;
     double g;
@@ -384,8 +404,9 @@ typedef struct _decor {
     Window	      event_windows[3][3];
     Window	      button_windows[BUTTON_NUM];
     guint	      button_states[BUTTON_NUM];
-    GdkPixmap	      *pixmap;
     GdkPixmap	      *buffer_pixmap;
+    GdkPixmap	      *pixmap;
+    GdkPixmap	      *active_pixmap;
     GdkGC	      *gc;
     decor_layout_t    border_layout;
     decor_context_t   *context;
@@ -477,32 +498,26 @@ static Window    switcher_selected_window = None;
 static XRenderPictFormat *xformat;
 
 static void
-decor_update_blur_property (decor_t *d,
-			    int     width,
-			    int     height,
-			    Region  top_region,
-			    int     top_offset,
-			    Region  bottom_region,
-			    int     bottom_offset,
-			    Region  left_region,
-			    int     left_offset,
-			    Region  right_region,
-			    int     right_offset)
+decor_update_box_property (decor_t *d,
+			   XID     xid,
+			   Atom    property,
+			   int     value0,
+			   int     value1,
+			   int     width,
+			   int     height,
+			   Region  top_region,
+			   int     top_offset,
+			   Region  bottom_region,
+			   int     bottom_offset,
+			   Region  left_region,
+			   int     left_offset,
+			   Region  right_region,
+			   int     right_offset)
 {
     Display *xdisplay = GDK_DISPLAY_XDISPLAY (gdk_display_get_default ());
     long    *data = NULL;
     int     size = 0;
 
-    if (blur_type != BLUR_TYPE_ALL)
-    {
-	bottom_region = NULL;
-	left_region   = NULL;
-	right_region  = NULL;
-
-	if (blur_type != BLUR_TYPE_TITLEBAR)
-	    top_region = NULL;
-    }
-
     if (top_region)
 	size += top_region->numRects;
     if (bottom_region)
@@ -517,15 +532,18 @@ decor_update_blur_property (decor_t *d,
 
     if (data)
     {
-	decor_region_to_blur_property (data, 4, 0, width, height,
-				       top_region, top_offset,
-				       bottom_region, bottom_offset,
-				       left_region, left_offset,
-				       right_region, right_offset);
+	data[0] = value0;
+	data[1] = value1;
+
+	decor_region_to_box_property (data + 2, width, height,
+				      top_region, top_offset,
+				      bottom_region, bottom_offset,
+				      left_region, left_offset,
+				      right_region, right_offset);
 
 	gdk_error_trap_push ();
-	XChangeProperty (xdisplay, d->prop_xid,
-			 win_blur_decor_atom,
+	XChangeProperty (xdisplay, xid,
+			 property,
 			 XA_INTEGER,
 			 32, PropModeReplace, (guchar *) data,
 			 2 + size * 6);
@@ -537,13 +555,52 @@ decor_update_blur_property (decor_t *d,
     else
     {
 	gdk_error_trap_push ();
-	XDeleteProperty (xdisplay, d->prop_xid, win_blur_decor_atom);
+	XDeleteProperty (xdisplay, xid, property);
 	gdk_display_sync (gdk_display_get_default ());
 	gdk_error_trap_pop ();
     }
 }
 
 static void
+decor_update_blur_property (decor_t *d,
+			    int     width,
+			    int     height,
+			    Region  top_region,
+			    int     top_offset,
+			    Region  bottom_region,
+			    int     bottom_offset,
+			    Region  left_region,
+			    int     left_offset,
+			    Region  right_region,
+			    int     right_offset)
+{
+    if (blur_type != BLUR_TYPE_ALL)
+    {
+	bottom_region = NULL;
+	left_region   = NULL;
+	right_region  = NULL;
+
+	if (blur_type != BLUR_TYPE_TITLEBAR)
+	    top_region = NULL;
+    }
+
+    decor_update_box_property (d,
+			       d->prop_xid,
+			       win_blur_decor_atom,
+			       4, 0,
+			       width,
+			       height,
+			       top_region,
+			       top_offset,
+			       bottom_region,
+			       bottom_offset,
+			       left_region,
+			       left_offset,
+			       right_region,
+			       right_offset);
+}
+
+static void
 decor_update_window_property (decor_t *d)
 {
     long	    data[256];
@@ -572,6 +629,24 @@ decor_update_window_property (decor_t *d)
 
     extents.top += titlebar_height;
 
+    if (d->active_pixmap)
+    {
+	decor_quads_to_property (data, GDK_PIXMAP_XID (d->active_pixmap),
+				 &extents, &extents,
+				 ICON_SPACE + d->button_width,
+				 0,
+				 quads, nQuad);
+
+	gdk_error_trap_push ();
+	XChangeProperty (xdisplay, d->prop_xid,
+			 win_decor_active_atom,
+			 win_decor_atom,
+			 32, PropModeReplace, (guchar *) data,
+			 BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
+	gdk_display_sync (gdk_display_get_default ());
+	gdk_error_trap_pop ();
+    }
+
     decor_quads_to_property (data, GDK_PIXMAP_XID (d->pixmap),
 			     &extents, &extents,
 			     ICON_SPACE + d->button_width,
@@ -581,7 +656,7 @@ decor_update_window_property (decor_t *d)
     gdk_error_trap_push ();
     XChangeProperty (xdisplay, d->prop_xid,
 		     win_decor_atom,
-		     XA_INTEGER,
+		     win_decor_atom,
 		     32, PropModeReplace, (guchar *) data,
 		     BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
     gdk_display_sync (gdk_display_get_default ());
@@ -650,7 +725,7 @@ decor_update_switcher_property (decor_t *d)
     gdk_error_trap_push ();
     XChangeProperty (xdisplay, d->prop_xid,
 		     win_decor_atom,
-		     XA_INTEGER,
+		     win_decor_atom,
 		     32, PropModeReplace, (guchar *) data,
 		     BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
     gdk_display_sync (gdk_display_get_default ());
@@ -976,7 +1051,9 @@ button_state_paint (cairo_t	  *cr,
 }
 
 static void
-draw_window_decoration (decor_t *d)
+draw_window_decoration_to_pixmap (decor_t   *d,
+				  GdkPixmap *pixmap,
+				  gint      active)
 {
     cairo_t       *cr;
     GtkStyle	  *style;
@@ -987,7 +1064,7 @@ draw_window_decoration (decor_t *d)
     int		  top;
     int		  button_x;
 
-    if (!d->pixmap)
+    if (!pixmap)
 	return;
 
     style = gtk_widget_get_style (style_window);
@@ -1003,7 +1080,7 @@ draw_window_decoration (decor_t *d)
     if (d->buffer_pixmap)
 	cr = gdk_cairo_create (GDK_DRAWABLE (d->buffer_pixmap));
     else
-	cr = gdk_cairo_create (GDK_DRAWABLE (d->pixmap));
+	cr = gdk_cairo_create (GDK_DRAWABLE (pixmap));
 
     cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
 
@@ -1020,7 +1097,7 @@ draw_window_decoration (decor_t *d)
 
     draw_shadow_background (d, cr, d->shadow, d->context);
 
-    if (d->active)
+    if (active)
     {
 	decor_color_t *title_color = _title_color;
 
@@ -1145,7 +1222,7 @@ draw_window_decoration (decor_t *d)
 
     cairo_set_operator (cr, CAIRO_OPERATOR_OVER);
 
-    if (d->active)
+    if (active)
     {
 	gdk_cairo_set_source_color_alpha (cr,
 					  &style->fg[GTK_STATE_NORMAL],
@@ -1219,7 +1296,7 @@ draw_window_decoration (decor_t *d)
 
 	button_x -= 17;
 
-	if (d->active)
+	if (active)
 	{
 	    cairo_move_to (cr, x, y);
 	    draw_close_button (d, cr, 3.0);
@@ -1247,7 +1324,7 @@ draw_window_decoration (decor_t *d)
 
 	cairo_set_fill_rule (cr, CAIRO_FILL_RULE_EVEN_ODD);
 
-	if (d->active)
+	if (active)
 	{
 	    gdk_cairo_set_source_color_alpha (cr,
 					      &style->fg[GTK_STATE_NORMAL],
@@ -1288,7 +1365,7 @@ draw_window_decoration (decor_t *d)
 
 	button_x -= 17;
 
-	if (d->active)
+	if (active)
 	{
 	    gdk_cairo_set_source_color_alpha (cr,
 					      &style->fg[GTK_STATE_NORMAL],
@@ -1311,7 +1388,7 @@ draw_window_decoration (decor_t *d)
 
     if (d->layout)
     {
-	if (d->active)
+	if (active)
 	{
 	    cairo_move_to (cr,
 			   d->context->left_space + 21.0,
@@ -1348,7 +1425,7 @@ draw_window_decoration (decor_t *d)
 	cairo_rectangle (cr, 0.0, 0.0, 16.0, 16.0);
 	cairo_clip (cr);
 
-	if (d->active)
+	if (active)
 	    cairo_paint (cr);
 	else
 	    cairo_paint_with_alpha (cr, alpha);
@@ -1357,7 +1434,7 @@ draw_window_decoration (decor_t *d)
     cairo_destroy (cr);
 
     if (d->buffer_pixmap)
-	gdk_draw_drawable  (d->pixmap,
+	gdk_draw_drawable  (pixmap,
 			    d->gc,
 			    d->buffer_pixmap,
 			    0,
@@ -1366,6 +1443,20 @@ draw_window_decoration (decor_t *d)
 			    0,
 			    d->width,
 			    d->height);
+}
+
+static void
+draw_window_decoration (decor_t *d)
+{
+    if (d->active_pixmap)
+    {
+	draw_window_decoration_to_pixmap (d, d->pixmap, FALSE);
+	draw_window_decoration_to_pixmap (d, d->active_pixmap, TRUE);
+    }
+    else
+    {
+	draw_window_decoration_to_pixmap (d, d->pixmap, d->active);
+    }		
 
     if (d->prop_xid)
     {
@@ -1430,6 +1521,24 @@ decor_update_meta_window_property (decor_t	  *d,
     extents.top += titlebar_height;
     max_extents.top += max_titlebar_height;
 
+    if (d->active_pixmap)
+    {
+	decor_quads_to_property (data, GDK_PIXMAP_XID (d->active_pixmap),
+				 &extents, &max_extents,
+				 ICON_SPACE + d->button_width,
+				 0,
+				 quads, nQuad);
+
+	gdk_error_trap_push ();
+	XChangeProperty (xdisplay, d->prop_xid,
+			 win_decor_active_atom,
+			 win_decor_atom,
+			 32, PropModeReplace, (guchar *) data,
+			 BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
+	gdk_display_sync (gdk_display_get_default ());
+	gdk_error_trap_pop ();
+    }
+
     decor_quads_to_property (data, GDK_PIXMAP_XID (d->pixmap),
 			     &extents, &max_extents,
 			     ICON_SPACE + d->button_width,
@@ -1439,7 +1548,7 @@ decor_update_meta_window_property (decor_t	  *d,
     gdk_error_trap_push ();
     XChangeProperty (xdisplay, d->prop_xid,
 		     win_decor_atom,
-		     XA_INTEGER,
+		     win_decor_atom,
 		     32, PropModeReplace, (guchar *) data,
 		     BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
     gdk_display_sync (gdk_display_get_default ());
@@ -1823,9 +1932,6 @@ meta_get_decoration_geometry (decor_t		*d,
     if (d->actions & WNCK_WINDOW_ACTION_SHADE)
 	*flags |= META_FRAME_ALLOWS_SHADE;
 
-    if (d->active)
-	*flags |= META_FRAME_HAS_FOCUS;
-
 #define META_MAXIMIZED (WNCK_WINDOW_STATE_MAXIMIZED_HORIZONTALLY | \
 			WNCK_WINDOW_STATE_MAXIMIZED_VERTICALLY)
 
@@ -1880,17 +1986,25 @@ meta_get_decoration_geometry (decor_t		*d,
 }
 
 static void
-meta_draw_window_decoration (decor_t *d)
+meta_draw_window_decoration_to_pixmap (decor_t        *d,
+				       GdkPixmap      *pixmap,
+				       MetaTheme      *theme,
+				       gint           active,
+				       gint           bg,
+				       Region         *top_region_return,
+				       Region         *bottom_region_return,
+				       Region         *left_region_return,
+				       Region         *right_region_return,
+				       MetaFrameFlags *flags_return)
 {
     Display	      *xdisplay =
 	GDK_DISPLAY_XDISPLAY (gdk_display_get_default ());
-    GdkPixmap	      *pixmap;
+    GdkPixmap         *pix;
     Picture	      src;
     MetaButtonState   button_states[META_BUTTON_TYPE_LAST];
     MetaButtonLayout  button_layout;
     MetaFrameGeometry fgeom;
     MetaFrameFlags    flags;
-    MetaTheme	      *theme;
     GtkStyle	      *style;
     cairo_t	      *cr;
     gint	      size, i;
@@ -1900,14 +2014,14 @@ meta_draw_window_decoration (decor_t *d)
     Region	      bottom_region = NULL;
     Region	      left_region = NULL;
     Region	      right_region = NULL;
-    double	      alpha = (d->active) ? meta_active_opacity : meta_opacity;
-    gboolean	      shade_alpha = (d->active) ? meta_active_shade_opacity :
+    double	      alpha = (active) ? meta_active_opacity : meta_opacity;
+    gboolean	      shade_alpha = (active) ? meta_active_shade_opacity :
 	meta_shade_opacity;
     MetaFrameStyle    *frame_style;
     GdkColor	      bg_color;
     double	      bg_alpha;
 
-    if (!d->pixmap || !d->picture)
+    if (!pixmap || !d->picture)
 	return;
 
     if (decoration_alpha == 1.0)
@@ -1915,20 +2029,19 @@ meta_draw_window_decoration (decor_t *d)
 
     style = gtk_widget_get_style (style_window);
 
-    drawable = d->buffer_pixmap ? d->buffer_pixmap : d->pixmap;
+    drawable = d->buffer_pixmap ? d->buffer_pixmap : pixmap;
 
     cr = gdk_cairo_create (GDK_DRAWABLE (drawable));
 
     cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
 
-    theme = meta_theme_get_current ();
-
     meta_get_decoration_geometry (d, theme, &flags, &fgeom, &button_layout,
 				  &clip);
 
-    /* we only have to redraw the shadow background when decoration
-       changed size */
-    if (d->prop_xid || !d->buffer_pixmap)
+    if (active)
+	flags |= META_FRAME_HAS_FOCUS;
+
+    if (bg)
 	draw_shadow_background (d, cr, d->shadow, d->context);
 
     for (i = 0; i < META_BUTTON_TYPE_LAST; i++)
@@ -1962,14 +2075,14 @@ meta_draw_window_decoration (decor_t *d)
 
     if (rect.width && size)
     {
-	pixmap = create_pixmap (rect.width, size);
+	pix = create_pixmap (rect.width, size);
 
-	cr = gdk_cairo_create (GDK_DRAWABLE (pixmap));
+	cr = gdk_cairo_create (GDK_DRAWABLE (pix));
 	gdk_cairo_set_source_color_alpha (cr, &bg_color, bg_alpha);
 	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
 
 	src = XRenderCreatePicture (xdisplay,
-				    GDK_PIXMAP_XID (pixmap),
+				    GDK_PIXMAP_XID (pix),
 				    xformat, 0, NULL);
 
 	if (fgeom.top_height)
@@ -1980,7 +2093,7 @@ meta_draw_window_decoration (decor_t *d)
 
 	    meta_theme_draw_frame (theme,
 				   style_window,
-				   pixmap,
+				   pix,
 				   &rect,
 				   0, 0,
 				   META_FRAME_TYPE_NORMAL,
@@ -2019,7 +2132,7 @@ meta_draw_window_decoration (decor_t *d)
 
 	    meta_theme_draw_frame (theme,
 				   style_window,
-				   pixmap,
+				   pix,
 				   &rect,
 				   0,
 				   -(clip.height - fgeom.bottom_height),
@@ -2053,7 +2166,7 @@ meta_draw_window_decoration (decor_t *d)
 
 	cairo_destroy (cr);
 
-	g_object_unref (G_OBJECT (pixmap));
+	g_object_unref (G_OBJECT (pix));
 
 	XRenderFreePicture (xdisplay, src);
     }
@@ -2064,14 +2177,14 @@ meta_draw_window_decoration (decor_t *d)
 
     if (size && rect.height)
     {
-	pixmap = create_pixmap (size, rect.height);
+	pix = create_pixmap (size, rect.height);
 
-	cr = gdk_cairo_create (GDK_DRAWABLE (pixmap));
+	cr = gdk_cairo_create (GDK_DRAWABLE (pix));
 	gdk_cairo_set_source_color_alpha (cr, &bg_color, bg_alpha);
 	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
 
 	src = XRenderCreatePicture (xdisplay,
-				    GDK_PIXMAP_XID (pixmap),
+				    GDK_PIXMAP_XID (pix),
 				    xformat, 0, NULL);
 
 	if (fgeom.left_width)
@@ -2082,7 +2195,7 @@ meta_draw_window_decoration (decor_t *d)
 
 	    meta_theme_draw_frame (theme,
 				   style_window,
-				   pixmap,
+				   pix,
 				   &rect,
 				   0,
 				   -fgeom.top_height,
@@ -2122,7 +2235,7 @@ meta_draw_window_decoration (decor_t *d)
 
 	    meta_theme_draw_frame (theme,
 				   style_window,
-				   pixmap,
+				   pix,
 				   &rect,
 				   -(clip.width - fgeom.right_width),
 				   -fgeom.top_height,
@@ -2156,13 +2269,13 @@ meta_draw_window_decoration (decor_t *d)
 
 	cairo_destroy (cr);
 
-	g_object_unref (G_OBJECT (pixmap));
+	g_object_unref (G_OBJECT (pix));
 
 	XRenderFreePicture (xdisplay, src);
     }
 
     if (d->buffer_pixmap)
-	gdk_draw_drawable  (d->pixmap,
+	gdk_draw_drawable  (pixmap,
 			    d->gc,
 			    d->buffer_pixmap,
 			    0,
@@ -2172,16 +2285,119 @@ meta_draw_window_decoration (decor_t *d)
 			    d->width,
 			    d->height);
 
-    if (d->prop_xid)
+    /* translate from frame to client window space */
+    if (top_region_return)
     {
-	/* translate from frame to client window space */
 	if (top_region)
 	    XOffsetRegion (top_region, -fgeom.left_width, -fgeom.top_height);
+
+	*top_region_return = top_region;
+    }
+    else if (top_region)
+    {
+	XDestroyRegion (top_region);
+    }
+
+    if (bottom_region_return)
+    {
 	if (bottom_region)
 	    XOffsetRegion (bottom_region, -fgeom.left_width, 0);
+
+	*bottom_region_return = bottom_region;
+    }
+    else if (bottom_region)
+    {
+	XDestroyRegion (bottom_region);
+    }
+
+    if (left_region_return)
+    {
 	if (left_region)
 	    XOffsetRegion (left_region, -fgeom.left_width, 0);
 
+	*left_region_return = left_region;
+    }
+    else if (left_region)
+    {
+	XDestroyRegion (left_region);
+    }
+
+    if (right_region_return)
+    {
+        *right_region_return = right_region;
+    }
+    else if (right_region)
+    {
+	XDestroyRegion (right_region);
+    }
+
+    *flags_return = flags;
+}
+
+static void
+meta_draw_window_decoration (decor_t *d)
+{
+    MetaTheme      *theme = meta_theme_get_current ();
+    MetaFrameFlags flags;
+    Region         top_region = NULL;
+    Region         bottom_region = NULL;
+    Region         left_region = NULL;
+    Region         right_region = NULL;
+    Region         *top_region_ptr = NULL;
+    Region         *bottom_region_ptr = NULL;
+    Region         *left_region_ptr = NULL;
+    Region         *right_region_ptr = NULL;
+    gint           bg = FALSE;
+
+    if (d->prop_xid)
+    {
+	bg = TRUE;
+
+	top_region_ptr    = &top_region;
+	bottom_region_ptr = &bottom_region;
+	left_region_ptr   = &left_region;
+	right_region_ptr  = &right_region;
+    }
+    else if (!d->buffer_pixmap)
+    {
+	bg = TRUE;
+    }
+
+    if (d->active_pixmap)
+    {
+	meta_draw_window_decoration_to_pixmap (d,
+					       d->pixmap,
+					       theme,
+					       FALSE,
+					       bg,
+					       NULL, NULL, NULL, NULL, &flags);
+	meta_draw_window_decoration_to_pixmap (d,
+					       d->active_pixmap,
+					       theme,
+					       TRUE,
+					       FALSE,
+					       top_region_ptr,
+					       bottom_region_ptr,
+					       left_region_ptr,
+					       right_region_ptr,
+					       &flags);
+    }
+    else
+    {
+	meta_draw_window_decoration_to_pixmap (d,
+					       d->pixmap,
+					       theme,
+					       d->active,
+					       bg,
+					       top_region_ptr,
+					       bottom_region_ptr,
+					       left_region_ptr,
+					       right_region_ptr,
+					       &flags);
+    }
+
+    if (d->prop_xid)
+    {
 	decor_update_meta_window_property (d, theme, flags,
 					   top_region,
 					   bottom_region,
@@ -2564,7 +2780,7 @@ update_default_decorations (GdkScreen *screen)
 
 	XChangeProperty (xdisplay, xroot,
 			 bareAtom,
-			 XA_INTEGER,
+			 win_decor_atom,
 			 32, PropModeReplace, (guchar *) data,
 			 BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
 
@@ -2572,12 +2788,12 @@ update_default_decorations (GdkScreen *screen)
 	{
 	    XChangeProperty (xdisplay, xroot,
 			     normalAtom,
-			     XA_INTEGER,
+			     win_decor_atom,
 			     32, PropModeReplace, (guchar *) data,
 			     BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
 	    XChangeProperty (xdisplay, xroot,
 			     activeAtom,
-			     XA_INTEGER,
+			     win_decor_atom,
 			     32, PropModeReplace, (guchar *) data,
 			     BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
 	}
@@ -2635,7 +2851,7 @@ update_default_decorations (GdkScreen *screen)
 
 	XChangeProperty (xdisplay, xroot,
 			 normalAtom,
-			 XA_INTEGER,
+			 win_decor_atom,
 			 32, PropModeReplace, (guchar *) data,
 			 BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
     }
@@ -2661,7 +2877,7 @@ update_default_decorations (GdkScreen *screen)
 
 	XChangeProperty (xdisplay, xroot,
 			 activeAtom,
-			 XA_INTEGER,
+			 win_decor_atom,
 			 32, PropModeReplace, (guchar *) data,
 			 BASE_PROP_SIZE + QUAD_PROP_SIZE * nQuad);
     }
@@ -3081,13 +3297,21 @@ update_event_windows (WnckWindow *win)
 {
     Display *xdisplay;
     decor_t *d = g_object_get_data (G_OBJECT (win), "decor");
-    gint    x0, y0, width, height, x, y, w, h;
+    Region  move_xregion;
+    REGION  xregion;
+    gint    x0, y0, x1, y1, width, height, x, y, w, h;
     gint    i, j, k, l;
     gint    actions = d->actions;
 
     xdisplay = GDK_DISPLAY_XDISPLAY (gdk_display_get_default ());
 
-    wnck_window_get_client_window_geometry (win, &x0, &y0, &width, &height);
+    wnck_window_get_geometry (win, &x0, &y0, &width, &height);
+    wnck_window_get_client_window_geometry (win, &x1, &y1, &width, &height);
+
+    move_xregion = XCreateRegion ();
+
+    xregion.rects = &xregion.extents;
+    xregion.numRects = xregion.size = 1;
 
     if (d->state & WNCK_WINDOW_STATE_SHADED)
     {
@@ -3134,6 +3358,16 @@ update_event_windows (WnckWindow *win)
 		XMapWindow (xdisplay, d->event_windows[i][j]);
 		XMoveResizeWindow (xdisplay, d->event_windows[i][j],
 				   x, y, w, h);
+
+		xregion.extents.x1 = x;
+		xregion.extents.y1 = y;
+		xregion.extents.x2 = x + w;
+		xregion.extents.y2 = y + h;
+
+		if (i == 1 && j == 1)
+		    XUnionRegion (move_xregion, &xregion, move_xregion);
+		else
+		    XSubtractRegion (move_xregion, &xregion, move_xregion);
 	    }
 	    else
 	    {
@@ -3181,6 +3415,13 @@ update_event_windows (WnckWindow *win)
 	{
 	    XMapWindow (xdisplay, d->button_windows[i]);
 	    XMoveResizeWindow (xdisplay, d->button_windows[i], x, y, w, h);
+
+	    xregion.extents.x1 = x;
+	    xregion.extents.y1 = y;
+	    xregion.extents.x2 = x + w;
+	    xregion.extents.y2 = y + h;
+
+	    XSubtractRegion (move_xregion, &xregion, move_xregion);
 	}
 	else
 	{
@@ -3188,6 +3429,28 @@ update_event_windows (WnckWindow *win)
 	}
     }
 
+    XOffsetRegion (move_xregion, x0 - x1, y0 - y1);
+
+    xregion.extents.x1 = 0;
+    xregion.extents.y1 = 0;
+    xregion.extents.x2 = width;
+    xregion.extents.y2 = height;
+
+    XSubtractRegion (move_xregion, &xregion, move_xregion);
+
+    decor_update_box_property (d,
+			       wnck_window_get_xid (win),
+			       wm_action_atom[1][1],
+			       0,
+			       1,
+			       width, height,
+			       move_xregion, width / 2,
+			       NULL, 0,
+			       NULL, 0,
+			       NULL, 0);
+
+    XDestroyRegion (move_xregion);
+
     gdk_display_sync (gdk_display_get_default ());
     gdk_error_trap_pop ();
 }
@@ -3488,7 +3751,7 @@ static gboolean
 update_window_decoration_size (WnckWindow *win)
 {
     decor_t   *d = g_object_get_data (G_OBJECT (win), "decor");
-    GdkPixmap *pixmap, *buffer_pixmap = NULL;
+    GdkPixmap *pixmap, *active_pixmap = NULL, *buffer_pixmap = NULL;
     Picture   picture;
     gint      width, height;
     gint      w, h, name_width;
@@ -3510,10 +3773,21 @@ update_window_decoration_size (WnckWindow *win)
     if (!pixmap)
 	return FALSE;
 
+    if (!reduced_resources)
+    {
+	active_pixmap = create_pixmap (width, height);
+	if (!active_pixmap)
+	{
+	    g_object_unref (G_OBJECT (pixmap));
+	    return FALSE;
+	}
+    }
+
     buffer_pixmap = create_pixmap (width, height);
     if (!buffer_pixmap)
     {
 	g_object_unref (G_OBJECT (pixmap));
+	g_object_unref (G_OBJECT (active_pixmap));
 	return FALSE;
     }
 
@@ -3523,6 +3797,9 @@ update_window_decoration_size (WnckWindow *win)
     if (d->pixmap)
 	g_object_unref (G_OBJECT (d->pixmap));
 
+    if (d->active_pixmap)
+	g_object_unref (G_OBJECT (d->active_pixmap));
+
     if (d->buffer_pixmap)
 	g_object_unref (G_OBJECT (d->buffer_pixmap));
 
@@ -3532,7 +3809,8 @@ update_window_decoration_size (WnckWindow *win)
     if (d->picture)
 	XRenderFreePicture (xdisplay, d->picture);
 
-    d->pixmap	     = pixmap;
+    d->pixmap        = pixmap;
+    d->active_pixmap = active_pixmap;
     d->buffer_pixmap = buffer_pixmap;
     d->gc	     = gdk_gc_new (pixmap);
 
@@ -3792,6 +4070,7 @@ update_switcher_window (WnckWindow *win,
     g_object_ref (G_OBJECT (buffer_pixmap));
 
     d->pixmap	     = pixmap;
+    d->active_pixmap = NULL;
     d->buffer_pixmap = buffer_pixmap;
     d->gc	     = gdk_gc_new (pixmap);
 
@@ -3822,6 +4101,12 @@ remove_frame_window (WnckWindow *win)
 	d->pixmap = NULL;
     }
 
+    if (d->active_pixmap)
+    {
+	g_object_unref (G_OBJECT (d->active_pixmap));
+	d->active_pixmap = NULL;
+    }
+
     if (d->buffer_pixmap)
     {
 	g_object_unref (G_OBJECT (d->buffer_pixmap));
@@ -3999,10 +4284,11 @@ active_window_changed (WnckScreen *screen)
     if (win)
     {
 	d = g_object_get_data (G_OBJECT (win), "decor");
-	if (d && d->pixmap)
+	if (d)
 	{
 	    d->active = wnck_window_is_active (win);
-	    queue_decor_draw (d);
+	    if (d->pixmap && !d->active_pixmap)
+		queue_decor_draw (d);
 	}
     }
 
@@ -4010,10 +4296,11 @@ active_window_changed (WnckScreen *screen)
     if (win)
     {
 	d = g_object_get_data (G_OBJECT (win), "decor");
-	if (d && d->pixmap)
+	if (d)
 	{
 	    d->active = wnck_window_is_active (win);
-	    queue_decor_draw (d);
+	    if (d->pixmap && !d->active_pixmap)
+		queue_decor_draw (d);
 	}
     }
 }
@@ -4746,7 +5033,8 @@ unstick_button_event (WnckWindow *win,
 static void
 handle_title_button_event (WnckWindow   *win,
 			   int          action,
-			   XButtonEvent *event)
+			   int          button,
+			   Time         time)
 {
     switch (action) {
     case CLICK_ACTION_SHADE:
@@ -4772,7 +5060,7 @@ handle_title_button_event (WnckWindow   *win,
 	restack_window (win, Below);
 	break;
     case CLICK_ACTION_MENU:
-	action_menu_map (win, event->button, event->time);
+	action_menu_map (win, button, time);
 	break;
     }
 }
@@ -4812,16 +5100,16 @@ dist (double x1, double y1,
     return sqrt (square (x1 - x2) + square (y1 - y2));
 }
 
+static int    last_button_num = 0;
+static Window last_button_xwindow = None;
+static Time   last_button_time = 0;
+static int    last_button_x = 0;
+static int    last_button_y = 0;
+
 static void
 title_event (WnckWindow *win,
 	     XEvent     *xevent)
 {
-    static int	  last_button_num = 0;
-    static Window last_button_xwindow = None;
-    static Time	  last_button_time = 0;
-    static int	  last_button_x = 0;
-    static int	  last_button_y = 0;
-
     if (xevent->type != ButtonPress)
 	return;
 
@@ -4834,7 +5122,8 @@ title_event (WnckWindow *win,
 		  last_button_x, last_button_y) < DOUBLE_CLICK_DISTANCE)
 	{
 	    handle_title_button_event (win, double_click_action,
-				       &xevent->xbutton);
+				       xevent->xbutton.button,
+				       xevent->xbutton.time);
 
 	    last_button_num	= 0;
 	    last_button_xwindow = None;
@@ -4858,12 +5147,14 @@ title_event (WnckWindow *win,
     else if (xevent->xbutton.button == 2)
     {
 	handle_title_button_event (win, middle_click_action,
-				   &xevent->xbutton);
+				   xevent->xbutton.button,
+				   xevent->xbutton.time);
     }
     else if (xevent->xbutton.button == 3)
     {
 	handle_title_button_event (win, right_click_action,
-				   &xevent->xbutton);
+				   xevent->xbutton.button,
+				   xevent->xbutton.time);
     }
     else if (xevent->xbutton.button == 4 ||
 	     xevent->xbutton.button == 5)
@@ -4887,11 +5178,13 @@ frame_common_event (WnckWindow *win,
 	break;
     case 2:
 	handle_title_button_event (win, middle_click_action,
-				   &xevent->xbutton);
+				   xevent->xbutton.button,
+				   xevent->xbutton.time);
 	break;
     case 3:
 	handle_title_button_event (win, right_click_action,
-				   &xevent->xbutton);
+				   xevent->xbutton.button,
+				   xevent->xbutton.time);
 	break;
     }
 }
@@ -5301,6 +5594,48 @@ event_filter_func (GdkXEvent *gdkxevent,
 		}
 	    }
 	}
+	else if (xevent->xclient.message_type == wm_action_notify_atom[1][1])
+	{
+	    WnckWindow *win;
+	    gulong     id = (gulong)
+		g_hash_table_lookup (frame_table,
+				     GINT_TO_POINTER (xevent->xclient.window));
+
+	    win = wnck_window_get (id);
+	    if (win)
+	    {
+		if (xevent->xclient.window    == last_button_xwindow &&
+		    xevent->xclient.data.l[0] == last_button_num     &&
+		    xevent->xclient.data.l[3] <
+		    last_button_time + double_click_timeout          &&
+		    dist (xevent->xclient.data.l[1],
+			  xevent->xclient.data.l[2],
+			  last_button_x,
+			  last_button_y) < DOUBLE_CLICK_DISTANCE)
+		{
+		    handle_title_button_event (win,
+					       double_click_action,
+					       xevent->xclient.data.l[0],
+					       xevent->xclient.data.l[3]);
+
+		    last_button_num	= 0;
+		    last_button_xwindow = None;
+		    last_button_time    = 0;
+		    last_button_x	= 0;
+		    last_button_y	= 0;
+		}
+		else
+		{
+		    last_button_num	= xevent->xclient.data.l[0];
+		    last_button_xwindow = xevent->xclient.window;
+		    last_button_time    = xevent->xclient.data.l[3];
+		    last_button_x	= xevent->xclient.data.l[1];
+		    last_button_y	= xevent->xclient.data.l[2];
+
+		    restack_window (win, Above);
+		}
+	    }
+	}
     default:
 	break;
     }
@@ -6909,6 +7244,10 @@ main (int argc, char *argv[])
 	{
 	    replace = TRUE;
 	}
+	else if (strcmp (argv[i], "--reduced-resources") == 0)
+	{
+	    reduced_resources = TRUE;
+	}
 	else if (strcmp (argv[i], "--blur") == 0)
 	{
 	    if (argc > ++i)
@@ -6957,6 +7296,7 @@ main (int argc, char *argv[])
 	    fprintf (stderr, "%s "
 		     "[--minimal] "
 		     "[--replace] "
+		     "[--reduced-resources] "
 		     "[--blur none|titlebar|all] "
 
 #ifdef USE_METACITY
@@ -6999,8 +7339,12 @@ main (int argc, char *argv[])
     xdisplay   = gdk_x11_display_get_xdisplay (gdkdisplay);
     gdkscreen  = gdk_display_get_default_screen (gdkdisplay);
 
+    win_decor_atom	  = XInternAtom (xdisplay, DECOR_WINDOW_ATOM_NAME,
+					 FALSE);
+    win_decor_active_atom = XInternAtom (xdisplay, DECOR_ACTIVE_ATOM_NAME,
+					 FALSE);
+
     frame_window_atom	= XInternAtom (xdisplay, "_NET_FRAME_WINDOW", FALSE);
-    win_decor_atom	= XInternAtom (xdisplay, DECOR_WINDOW_ATOM_NAME, FALSE);
     win_blur_decor_atom	= XInternAtom (xdisplay, DECOR_BLUR_ATOM_NAME, FALSE);
     wm_move_resize_atom = XInternAtom (xdisplay, "_NET_WM_MOVERESIZE", FALSE);
     restack_window_atom = XInternAtom (xdisplay, "_NET_RESTACK_WINDOW", FALSE);
@@ -7027,6 +7371,23 @@ main (int argc, char *argv[])
     panel_action_run_dialog_atom =
 	XInternAtom (xdisplay, "_GNOME_PANEL_ACTION_RUN_DIALOG", FALSE);
 
+    for (i = 0; i < 3; i++)
+	for (j = 0; j < 3; j++)
+	    wm_action_atom[i][j] = XInternAtom (xdisplay,
+						wm_action_name[i][j],
+						FALSE);
+
+    for (i = 0; i < 3; i++)
+    {
+	char name[256];
+
+	for (j = 0; j < 3; j++)
+	{
+	    sprintf (name, "%s_NOTIFY", wm_action_name[i][j]);
+	    wm_action_notify_atom[i][j] = XInternAtom (xdisplay, name, FALSE);
+	}
+    }
+
     status = decor_acquire_dm_session (xdisplay,
 				       gdk_screen_get_number (gdkscreen),
 				       "gwd", replace, &dm_sn_timestamp);
